<?php

namespace MF\BetterBlogsImporter;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
    {
        if($this->tableExists('xfa_blog_entry'))
        {
            $this->migrateTableToReactions('xfa_blog_entry');
        }
    }

    public function installStep2()
	{
        if($this->tableExists('xfa_blog_comment'))
        {
            $this->migrateTableToReactions('xfa_blog_comment');
        }

	}

	public function installStep3()
    {
        if($this->tableExists('xf_xa_ubs_blog_entry'))
        {
            $this->schemaManager()->alterTable('xf_xa_ubs_blog_entry', function (Alter $table)
            {
                $table->addColumn('xfa_entry_id','int')->setDefault('0');
            });
        }

    }

    public function installStep4()
    {
        if($this->tableExists('xf_xa_ubs_comment'))
        {
            $this->schemaManager()->alterTable('xf_xa_ubs_comment', function (Alter $table)
            {
                $table->addColumn('xfa_comment_id','int')->setDefault('0');
            });
        }

    }

    public function uninstallStep1()
    {
        if($this->schemaManager()->columnExists('xf_xa_ubs_blog_entry','xfa_entry_id'))
        {
            $this->schemaManager()->alterTable('xf_xa_ubs_blog_entry', function (Alter $table)
            {
                $table->dropColumns('xfa_entry_id');
            });
        }

    }

    public function uninstallStep2()
    {
        if($this->schemaManager()->columnExists('xf_xa_ubs_comment','xfa_comment_id'))
        {
            $this->schemaManager()->alterTable('xf_xa_ubs_comment', function (Alter $table) {
                $table->dropColumns('xfa_comment_id');
            });
        }
    }

    public function uninstallStep3()
    {
        $this->schemaManager()->dropTable('mf_import_resume');
    }

    public function tableExists($tableName)
    {
        return $this->schemaManager()->tableExists($tableName);
    }


}